package org.mitre.jcarafe.util

import util.matching.Regex

object ConvertCoNLLDepFormatToLex {
  
  def getLineInfoStd(lineRx: Regex)(line: String) : (String,String,Int,Int,String) = {
    val lineRx(ind,tok,_,pos1,_,_,gov,lab,_,_) = line
    (tok,pos1,ind.toInt,gov.toInt,lab)
  }
  
  val ampR = "&".r
  
  private def escape(s: String) = ampR.replaceAllIn(s,"&amp;")

  def main (args: Array[String]) = {
    val src = io.Source.fromFile(new java.io.File(args(0)))("UTF-8")
    val ostr = new java.io.FileOutputStream(new java.io.File(args(1)))
    val std = ((args.length < 3) || (args(2) == "std"))
    val os = new java.io.OutputStreamWriter(new java.io.BufferedOutputStream(ostr), "UTF-8")
    var lines = src.getLines()
    val lineFn = getLineInfoStd("""(\S+)\t(\S+)\t(\S+)\t(\S+)\t(\S+)\t(\S+)\t(\S+)\t(\S+)\t(\S+)\t(\S+).*""".r) _
    var starting = false
    os.write("<DOC>\n")
    os.write("<s>")
    lines foreach {line =>
      if (line.length < 5) { // new sentence
        os.write("</s>\n")
        starting = true
      }
      else {
        if (starting) {os.write("<s>"); starting = false}
    	val (tok,pos,ind,gov,lab) = lineFn(line)
    	val gv = if (gov == 0) ind else gov
    	os.write("<lex pos=\"" + pos + "\" gov=\"" + (gv-1) + "\" lab=\"" + lab + "\">" + escape(tok) + "</lex> ")
      } 	
    }
    if (!starting) os.write("</s>\n")
    os.write("</DOC>")
    os.flush()
    os.close()
  }
}